USE adventureworks;
GO

ALTER PROCEDURE sp1
(
@CustomerID int
)
AS
/*
A more useful SP, with a parameter.

* Pass in a parameter to make it dynamic.
* Don't DECLARE the parameter, but it does need a data type.
* Officially, the parameters don't need to be in () either, 
but it's a really good idea to physically separate them.
* Here we probably won't get any data back and there are a 
number of ways we can solve that.
*/

SELECT OrderQty,Name,ListPrice
  FROM SalesLT.SalesOrderHeader 
  INNER JOIN SalesLT.SalesOrderDetail
          ON SalesOrderDetail.SalesOrderID = SalesOrderHeader.SalesOrderID
  INNER JOIN SalesLT.Product
          ON SalesOrderDetail.ProductID=Product.ProductID
WHERE CustomerID = @CustomerID;