USE adventureworks;
GO

ALTER PROCEDURE sp1
(
@CustomerID int
)
AS
/*
In the last one we got nothing when there was no data.
Here's one way to solve it.

* The #table here is needed to keep from hittin the table again.
If we didn't have it we would have to count the rows that would be returned,
and if there were rows, we'd have to query the same tables again to get
the actual data.  This way we hit the tables only once.
* The problem here is that we've broken the contract.  This can
be easy to do and you just have to think about what you're doing.
* The contract was broken because the 2 possible results don't
have the same shape.

Returns data
dbo.sp1 140
No data
dbo.sp1 1234
*/


CREATE TABLE #T1
(
OrderQty smallint,
NAME nvarchar(50),
ListPrice money
)

INSERT #T1 (OrderQty, NAME, ListPrice)
SELECT OrderQty,Name,ListPrice--, customerid
  FROM SalesLT.SalesOrderHeader 
  INNER JOIN SalesLT.SalesOrderDetail
          ON SalesOrderDetail.SalesOrderID = SalesOrderHeader.SalesOrderID
  INNER JOIN SalesLT.Product
          ON SalesOrderDetail.ProductID=Product.ProductID
WHERE CustomerID = @CustomerID;

IF (SELECT COUNT (*) FROM #T1) > 0
	BEGIN --Always comment 1
		SELECT * FROM #T1;
	END --Always comment 1
ELSE
	BEGIN --Always comment 2
		SELECT 'No data';
	END --Always comment 2
