USE adventureworks;
GO

ALTER PROCEDURE dbo.sp1
(
@CustomerID int
)
AS
/*
Here we're using a local var to store the count of records.

* Local parameters are very useful for holding values that you'll
use again and again.
* These do have to be declared.

Returns data
dbo.sp1 140
No data
dbo.sp1 1234
*/

DECLARE @ExecDate DATETIME,
		@CT int; --Holds count of records to compare.
SET @ExecDate = GETDATE();

CREATE TABLE #T1
(
OrderQty smallint,
NAME nvarchar(50),
ListPrice money
)

INSERT #T1 (OrderQty, NAME, ListPrice)
SELECT OrderQty,Name,ListPrice
  FROM SalesLT.SalesOrderHeader 
  INNER JOIN SalesLT.SalesOrderDetail
          ON SalesOrderDetail.SalesOrderID = SalesOrderHeader.SalesOrderID
  INNER JOIN SalesLT.Product
          ON SalesOrderDetail.ProductID=Product.ProductID
WHERE CustomerID = @CustomerID;

SET @CT = (SELECT COUNT (*) FROM #T1);

IF @CT > 0
	BEGIN --Always comment 1
		SELECT @ExecDate AS ExecDate, * FROM T1;
	END --Always comment 1
ELSE
	BEGIN --Always comment 2
		SELECT NULL AS ExecDate, NULL AS OrderQty, 'No data' AS Name, NULL AS ListPrice;
	END --Always comment 2
