USE adventureworks;
GO

ALTER PROCEDURE dbo.sp1
(
@CustomerID INT, --CustID from dbo.customer table.
@Log BIT --0|1. Whether to log to table.
)
AS
/*
Multiple input params.

* Separate multiple input params with commas.

Log table:
CREATE TABLE QueryLog
(
ExecDate DATETIME,
CustomerID INT,
RowCT int
)

Returns data
dbo.sp1 140, 0
No data
dbo.sp1 1234, 0
*/

DECLARE @ExecDate DATETIME,
		@CT int; --Holds count of records to compare.
SET @ExecDate = GETDATE();

CREATE TABLE #T1
(
OrderQty smallint,
NAME nvarchar(50),
ListPrice money
);

INSERT #T1 (OrderQty, NAME, ListPrice)
SELECT OrderQty,Name,ListPrice
  FROM SalesLT.SalesOrderHeader 
  INNER JOIN SalesLT.SalesOrderDetail
          ON SalesOrderDetail.SalesOrderID = SalesOrderHeader.SalesOrderID
  INNER JOIN SalesLT.Product
          ON SalesOrderDetail.ProductID=Product.ProductID
WHERE CustomerID = @CustomerID;

SET @CT = (SELECT COUNT (*) FROM #T1);

IF @CT > 0
	BEGIN --Always comment 1
		SELECT @ExecDate AS ExecDate, * FROM T1;
	END --Always comment 1
ELSE
	BEGIN --Always comment 2
		SELECT NULL AS ExecDate, NULL AS OrderQty, 'No data' AS Name, NULL AS ListPrice;
	END --Always comment 2

IF @Log = 1
	BEGIN
		INSERT  QueryLog(ExecDate, CustomerID, RowCT)
		SELECT @ExecDate, @CustomerID, @CT;
	END

